<?php
/**
 * @version        	2.3.4
 * @package        	OS Services Booking
 * @subpackage		Payment Plugins
 * @author  		Dang Thuc Dam
 * @copyright    	Copyright (C) 2010 - 2015 Ossolution Team
 * @license        	GNU/GPL, see LICENSE.php
 */
defined('_JEXEC') or die();

/**
 * Strie payment plugin for OS Services Booking
 * 
 * @author Dang Thuc Dam
 *        
 */
class os_stripe extends os_payment
{
	
	/**
	 * Payment plugin param
	 * 
	 * @var JRegistry
	 */	
	protected $params;
	/**
	 * Constructors function
	 *  
	 * @param JRegistry $params
	 */
	function os_stripe($params)
	{
		require_once __DIR__.'/stripe/Stripe.php';
		parent::setName('os_stripe');
		parent::os_payment();
		parent::setCreditCard(true);
		parent::setCardType(true);
		parent::setCardCvv(true);
		parent::setCardHolderName(true);
		$this->params = $params;		
	}

	/**
	 * Set parametter for processing payment
	 *
	 * @param string $key        	
	 * @param string $value        	
	 */
	function setParam($key, $value)
	{
		$this->params[$key] = $value;
	}

	/**
	 * Process Payment
	 *
	 * @param array $data        	
	 */
	function processPayment($row, $data)
	{
		$app = JFactory::getApplication();
		$Itemid = JRequest::getInt('Itemid');
		$itemName = $data['item_name'];
		Stripe::setApiKey($this->params->get('stripe_api_key'));
		$request = array(
			'amount' => 100*round($data['amount'], 2),
			'currency' => $this->params->get('stripe_currency', 'usd'),
			'description' => $itemName,
			'card' => array(
				'number' => $data['x_card_num'],
				'exp_month' => 	$data['exp_month'],
				'exp_year' => $data['exp_year'],
				'cvc' => $data['x_card_code'],
				'name' => $data['card_holder_name']
			)
		);		
		try 
		{
			$charge = Stripe_Charge::create($request);
			$db->setQuery("UPDATE #__app_sch_orders SET transaction_id = '".$charge->id."', order_status = 'S' WHERE id = '$row->id'");
        	$db->query();
			OsAppscheduleDefault::paymentComplete($row->id);
			$app->redirect(JRoute::_(JURI::root().'index.php?option=com_osservicesbooking&task=default_paymentreturn&id='.$row->id, false, false));
			return true;
		}
		catch (Exception $e)
		{
			$_SESSION['reason'] = $e->getMessage();
			$mainframe->redirect(JRoute::_('index.php?option=com_osservicesbooking&task=default_paymentfailure&id='.$row->id, false, false),$e->getMessage());
			return false;
		}						
	}
}